#!/usr/bin/env ruby
#
# 2006.08.16 新規作成
# 2006.08.20 進捗処理追加
#            検索処理のバグ修正       
# 2006.08.25 プロキシに対応したつもり
#            UserAgentを返すようにした
#            中断できるようにしたがスレッドが不安
#            ダウンロード時、確認ダイアログを出す
#            user検索機能追加
# 2006.09.01 全面改装
# 2006.09.02 一括ダウンロードの仕様変更
# 2006.09.16 出力先デフォルトを設定
# 2006.12.02 youtubeの仕様変更に合わせ正規表現を変更
# 2007.01.03 再生ダイアログ追加
# 2007.02.24 YouTubeの仕様変更に合わせました。
# 2007.09.09 YouTubeの仕様変更に合わせました。
# 2008.01.03 YouTubeの仕様変更に合わせました。
# 2008.04.30 YouTubeの仕様変更に合わせました。
# 2008.04.30 uaをnetfrontにもどしました

# youtube player and downloader
# 


#    if !@fork.nil?
#      @send.write("quit\n")
#      system("killall mplayer >/dev/null 2>&1")
#      @fork=nil
#      @send=nil
#    end

require 'cgi'
require 'uri'
require 'net/http'

require "qte"
require "qpe"

include Qte
include Qpe

$zvol          = '/home/QtPalmtop/bin/zvol'
#$str_mplayer   = 'mplayer -slave -double -really-quiet -framedrop -double -cache '
$str_mplayer   = 'mplayer -slave -framedrop -cache '
$str_name      = 'qrtube 0.261'

class ObjShare
  def initialize()
    @config = Config.new(tr('qrtube'))
    @config.setGroup(tr('setting'))

    @str_dir  =@config.readEntry(tr('qrWork')).local8Bit().to_str()
    @str_proxy=@config.readEntry(tr('qrProxy')).local8Bit().to_str()
    @n_port   =@config.readEntry(tr('qrPort')).local8Bit().to_str().to_i()
    @n_timeout=@config.readEntry(tr('qrTimeout')).local8Bit().to_str().to_i()
    @n_name  =@config.readEntry(tr('qrName')).local8Bit().to_str().to_i()
    @n_cache  =@config.readEntry(tr('qrCache')).local8Bit().to_str().to_i()
    @n_playmode  =@config.readEntry(tr('qrPlaymode')).local8Bit().to_str().to_i()

    product = `cat /proc/deviceinfo/product`
    product.chomp!
  
    case product
    when 'SL-C3000'
      @str_videoOpt = '-quiet -vo bvdd -vm -framedrop'
    when 'SL-C1000'
      @str_videoOpt = '-quiet -vo bvdd -vm -framedrop'
    when 'SL-C3100'
      @str_videoOpt = '-quiet -vo bvdd -vm -autosync 100'
    else    # SL-C[78]?0
      @str_videoOpt = '-quiet -vo w100 -fs -vf rotate=1'
    end
    @str_videoOpt2 = '-quiet -fs -vf rotate=1'

    @ua="Mozilla/4.08 (PDA; "+product+"/1.0,Qtopia/1.5.4) NetFront/3.1"
#    @ua="Mozilla/4.0 (compatible; MSIE 6.0; Windows NT5.1; .NET CLR 1.1.4322)"
    @ap='*/*'
    @al='ja'
    @ac='utf-8'
    
    @t=nil
    @breakMe=false
    @update=false
    @send=nil
    @folk=nil
  end

  def exit()
    if @update
      @config.setGroup(tr('setting'))
      @config.writeEntry(tr('qrWork') ,tr(@str_dir))
      @config.writeEntry(tr('qrProxy'),tr(@str_proxy))
      @config.writeEntry(tr('qrPort') ,tr(@n_port.to_s()))
      @config.writeEntry(tr('qrTimeout') ,tr(@n_timeout.to_s()))
      @config.writeEntry(tr('qrName') ,tr(@n_name.to_s()))
      @config.writeEntry(tr('qrCache') ,tr(@n_cache.to_s()))
      @config.writeEntry(tr('qrPlaymode') ,tr(@n_playmode.to_s()))
    end  
#    threadWait()
  end

  attr_accessor :ua, :ap, :al, :ac

  def threadSave(t)
    @t=t
  end

  def threadWait()
begin
    if @t
      if @t.alive?
        @breakMe=true
        @t.join()
        @t=nil 
        return true
      end
    end
    return false
rescue Exception
    return true
end
  end

  def threadAlive()
    if @t
      if @t.alive?
        return true
      end
    end
    return false
  end

  def resetBreak()
    @breakMe=false
  end

  def isBreak()
    return @breakMe
  end

  def isVga()
    if (QPEApplication.desktop.width > 320)
      return true
    else
      return false
    end
  end
  
  def update()
    @update=true
  end

  def setName(n_name)
    @n_name=n_name
  end

  def getName()
    return @n_name
  end

  def setDir(str_dir)
    @str_dir=str_dir
  end

  def getDir()
    if @str_dir==''
      return QPEApplication.documentDir().local8Bit().to_str()
    end
    return @str_dir
  end
  
  def setPort(n_port)
    @n_port=n_port
    if @n_port==0
      @n_port=80
    end
  end

  def getTimeout()
    return @n_timeout
  end

  def getTimeout2()
    list=[15,30,45,60,120]
    if @n_timeout>4 || @n_timeout<0
      @n_timeout=0
    end
    return list[@n_timeout]
  end

  def setTimeout(n_timeout)
    @n_timeout=n_timeout
  end

  def getPort()
    return @n_port
  end
  
  def setProxy(str_proxy)
    @str_proxy=str_proxy
  end
  
  def getProxy(mode)
    tmp =@str_proxy
    if tmp=="" && mode==1
        tmp=nil
    end
    return tmp
  end
  
  def setCache(n_cache)
    @n_cache=n_cache
  end

  def getCache()
   if @n_cache>4 || @n_cache<0
       @n_cache=0
    end
    return @n_cache
  end
  def getCache2()
    list=[384,1024,2048,3072,4096]
    return list[getCache]
  end

  def setPlaymode(n_playmode)
    @n_playmode=n_playmode
  end

  def getPlaymode()
    return @n_playmode
  end
  
  def getPlayoption()
    if getPlaymode()==2
      return @str_videoOpt2
    else
      return @str_videoOpt
    end
  end
end

class QSettingWindow < QWidget
  def initialize(parent,setting)
    super(parent)
    @parent=parent
    @setting=setting

    @lays1=QVBoxLayout.new(self)
    @lays2=QHBoxLayout.new(self)
    @lays3=QHBoxLayout.new(self)
    @lays4=QHBoxLayout.new(self)
    @lays5=QHBoxLayout.new(self)
    @lays6=QHBoxLayout.new(self)

    @label1=QLabel.new(tr('作業フォルダ:'),self)
    @lays2.addWidget(@label1)
    @eboxs1 = QLineEdit.new(self)
    @lays2.addWidget(@eboxs1)

    @label2=QLabel.new(tr('プロキシ:'),self)
    @lays3.addWidget(@label2)
    @eboxs2 = QLineEdit.new(self)
    @lays3.addWidget(@eboxs2)

    @label3=QLabel.new(tr('ポート:'),self)
    @lays3.addWidget(@label3)
    @eboxs3 = QLineEdit.new(self)
    @eboxs3.setMaximumWidth(100)
    @lays3.addWidget(@eboxs3)

    @label4=QLabel.new(tr('タイムアウト時間:'),self)
    @lays4.addWidget(@label4)
    @cb1 = QComboBox.new(self)
    @lays4.addWidget(@cb1)

    @cb1.insertItem(tr('15'),-1)
    @cb1.insertItem(tr('30'),-1)
    @cb1.insertItem(tr('45'),-1)
    @cb1.insertItem(tr('60'),-1)
    @cb1.insertItem(tr('120'),-1)

    @label5=QLabel.new(tr('IDファイル名:'),self)
    @lays4.addWidget(@label5)
    @cb2 = QComboBox.new(self)
    @lays4.addWidget(@cb2)

    @cb2.insertItem(tr('いいえ'),-1)
    @cb2.insertItem(tr('はい'),-1)

    @label6=QLabel.new(tr('再生キャッシュ:'),self)
    @lays5.addWidget(@label6)
    @cb3 = QComboBox.new(self)
    @lays5.addWidget(@cb3)

    @cb3.insertItem(tr('384'),-1)
    @cb3.insertItem(tr('1024'),-1)
    @cb3.insertItem(tr('2048'),-1)
    @cb3.insertItem(tr('3072'),-1)
    @cb3.insertItem(tr('4096'),-1)

    @label7=QLabel.new(tr('再生モード:'),self)
    @lays5.addWidget(@label7)
    @cb4 = QComboBox.new(self)
    @lays5.addWidget(@cb4)
    @cb4.insertItem(tr('未使用'),-1)
    @cb4.insertItem(tr('高速モード'),-1)
    @cb4.insertItem(tr('安全モード'),-1)


    @bs1 = QPushButton.new(tr("更新"),self)
    @lays6.addWidget(@bs1)

    @bs2 = QPushButton.new(tr("戻す"),self)
    @lays6.addWidget(@bs2)

    @key = QAccel.new(self)
    @key.connectItem(@key.insertItem(Qt::Key_Enter+CTRL ,101), self, 'accept')
    @key.connectItem(@key.insertItem(Qt::Key_Return+CTRL,102), self, 'accept')
    @key.connectItem(@key.insertItem(Qt::Key_U+CTRL     ,103), self, 'reject')

    connect(@bs1,QSIGNAL("clicked()"), self, 'accept')
    connect(@bs2,QSIGNAL("clicked()"), self, 'reject')

    @lays1.addLayout(@lays2)
    @lays1.addLayout(@lays3)
    @lays1.addLayout(@lays4)
    @lays1.addLayout(@lays5)
    @lays1.addLayout(@lays6)

    reject()
  end 

  def reject()
    str_dir=@setting.getDir()
#    if str_dir==''
#      str_dir=QPEApplication.documentDir().local8Bit().to_str()
#    end
    @eboxs1.setText(tr(str_dir))
    @eboxs2.setText(tr(@setting.getProxy(0)))
    @eboxs3.setText(tr(@setting.getPort().to_s()))
    @cb1.setCurrentItem(@setting.getTimeout())
    @cb2.setCurrentItem(@setting.getName())
    @cb3.setCurrentItem(@setting.getCache())
    @cb4.setCurrentItem(@setting.getPlaymode())
  end

  def accept()
    str_dir=@eboxs1.text().local8Bit().to_str()
    if str_dir==''
      str_dir=QPEApplication.documentDir().local8Bit().to_str()
    end
    @setting.setDir(@eboxs1.text().local8Bit().to_str())
    @setting.setProxy(@eboxs2.text().local8Bit().to_str())
    @setting.setPort(@eboxs3.text().local8Bit().to_str().to_i())
    @setting.setTimeout(@cb1.currentItem())
    @setting.setName(@cb2.currentItem())
    @setting.setCache(@cb3.currentItem())
    @setting.setPlaymode(@cb4.currentItem())
    @setting.update()
  end  

  def setEnableMode(b_mode)
    3.times do |l|
      @key.setItemEnabled(101+l,b_mode)
    end
  end
  
end

class QDownloadWindow < QWidget
  def initialize(parent,setting)
    super(parent)
    @parent=parent
    @setting=setting

    @lays1=QVBoxLayout.new(self)
    @lays2=QHBoxLayout.new(self)
    @lays3=QHBoxLayout.new(self)

    @list = QListView.new(self)
    @list.setSelectionMode(0)
    @list.setMultiSelection(false)

    @list.addColumn(tr('・'))
    @list.addColumn(tr('Title'))
    @list.addColumn(tr('Time'))
    @list.addColumn(tr('User'))
    @list.addColumn(tr('ID'))
    @list.setAllColumnsShowFocus(true)
    @list.setColumnWidth(0, 5)
    @list.setColumnWidth(1, 440)
    @list.setColumnWidth(2, 60)
    @list.setColumnWidth(3, 100)
    @list.setColumnWidth(4, 100)

    @bt1=QPushButton.new(tr('全削除'),self)
    connect(@bt1,QSIGNAL("clicked()"), self, 'clear')
    @bt2=QPushButton.new(tr('一行削除'),self)
    connect(@bt2,QSIGNAL("clicked()"), self, 'delete')
    @bt3=QPushButton.new(tr('ダウンロード'),self)
    connect(@bt3,QSIGNAL("clicked()"), self, 'download')

    @lb1 = QLabel.new(tr('--'),self)

    if @setting.isVga()
      @lb1.setMinimumWidth(320)
    else
      @lb1.setMinimumWidth(160)
    end

    @pb1 = QProgressBar.new(self)

    @lays1.addWidget(@list)
    @lays1.addLayout(@lays2)
    @lays1.addLayout(@lays3)
    @lays2.addWidget(@bt1)
    @lays2.addWidget(@bt2)
    @lays2.addWidget(@bt3)
    @lays3.addWidget(@lb1)
    @lays3.addWidget(@pb1)

    @key = QAccel.new(self)
    @key.connectItem(@key.insertItem(Qt::Key_Enter,       91), self, 'download')
    @key.connectItem(@key.insertItem(Qt::Key_Return,      92), self, 'download')
    @key.connectItem(@key.insertItem(Qt::Key_C+CTRL,     101), self, 'clear')
    @key.connectItem(@key.insertItem(Qt::Key_D+CTRL,     102), self, 'delete')
    @key.connectItem(@key.insertItem(Qt::Key_Return+SHIFT,103), self, 'tabChange')
  end

  def setEnableMode(b_mode)
    @list.setEnabled(b_mode)
    @parent.setEnabledTab(2,b_mode)

    3.times do |l|
      @key.setItemEnabled(101+l,b_mode)
    end
  end

  def setGui(n_state)
    if n_state==3
      @lb1.setText(tr('--'))
      @pb1.setProgress(0)
      setEnableMode(false)
      @bt1.setEnabled(false)
      @bt2.setEnabled(false)
      @bt3.setText(tr('キャンセル'))    
    end

    if n_state==4
      @lb1.setText(tr('--'))
      @pb1.setProgress(0)
      setEnableMode(true)
      @bt1.setEnabled(true)
      @bt2.setEnabled(true)
      @bt3.setText(tr('ダウンロード'))    
    end

    if n_state==5
      @lb1.setText(tr('通信エラー'))
      @pb1.setProgress(0)
      setEnableMode(true)
      @bt1.setEnabled(true)
      @bt2.setEnabled(true)
      @bt3.setText(tr('ダウンロード'))    
    end
  end 

  def tabChange()
    @parent.setPage(1)
  end
  
  def clear()
    @list.clear()
  end
  
  def delete()
    item = @list.firstChild()
    itemo=item
    while ( not item.nil? )
      if item.isSelected
        @list.removeItem(item)
      end
      item = item.nextSibling()
    end    
  end

  def insert(str_title,str_time,str_user,str_id)
    item = @list.firstChild()
    while ( not item.nil? )
      if str_id==item.text(3).local8Bit().to_str()
        return
      end
      item = item.nextSibling()
    end

    QListViewItem.new(@list,tr('□'),str_title, str_time, str_user, str_id)
  end

  def listSelected()
    n_count=0
    item = @list.firstChild()
    while ( not item.nil? )
      if item.isSelected
        n_count+=1
      end
      item = item.nextSibling()
    end

    return n_count
  end

  def downloadUri(str_id,proxy_class,setting)
  
    str_redirect_url = ''

    http=proxy_class.new('www.youtube.com')
    http.open_timeout=setting.getTimeout2()
    http.read_timeout=setting.getTimeout2()
    http.start do |http|
      r= http.get("/watch_video/v/#{str_id}",'User-Agent'=>setting.ua)
      str_redirect_url = r["location"]
    end

    if setting.isBreak()
      return
    end

    query = Hash.new('')
    str_redirect_url.split(/\?/,2)[1].split(/&/).each do |q|
      key, value = q.split(/=/)
      query[key] = value
    end
  
    http.start do |http|
      r = http.get("/get_video?video_id=#{query['video_id']}&t=#{query['t']}",'User-Agent'=>setting.ua)
      str_redirect_url = r["location"]
    end

    return str_redirect_url
  end

  def download2(setting,proxy_class,download_url,file)
  begin
      if /http:\/\/([^\/]+)(.+)/i =~ download_url
        host=$1
        dir=$2
        n_currentlen=0
        http = proxy_class.new(host)
        http.open_timeout=setting.getTimeout2()
        http.read_timeout=setting.getTimeout2()
        http.start do |https|
          res = https.head(dir)
          str_redirect_url = res["location"]
          alllen=res['Content-Length'].to_i
          if alllen == 0
            if /http:\/\/([^\/]+)(.+)/i =~ str_redirect_url
                return str_redirect_url
            end
          end
          if alllen<=0
            alllen=100
          end
          https.get(dir,'User-Agent'=>setting.ua) do |byte|
            if setting.isBreak()
              return -100
            end
            n_currentlen+=byte.length
            @pb1.setProgress(n_currentlen*100/alllen)
            file.print byte
          end
        end 
      end
      return 'get' 
    rescue
      return 'notget'
    end
  end

  def downloadId(str_name, str_id, setting)
begin
    proxy_class =Net::HTTP::Proxy(setting.getProxy(1),setting.getPort())
    download_url = downloadUri(str_id,proxy_class,setting)
    if setting.isBreak()
     return -100
    end

    filename=str_id+'.flv'
    if setting.getName()==0
      filename=str_name.gsub(/[\\\/:,;*\?"<>| ]/,'_')+'.flv'
    end
    filepath=setting.getDir().gsub(/\/$/,"")+'/'+filename

    open(filepath, "w+b") do |file|
      while 1
        download_url = download2(setting,proxy_class,download_url,file)
        puts download_url
        unless /http:\/\/([^\/]+)(.+)/i =~ download_url
          break
        end
      end
    end

  return 0
  rescue Exception
  puts "Exception"
  return 1
  rescue Errno::ETIMEDOUT
  puts "Errno::ETIMEDOUT"
  return 1
  rescue TimeoutError
  puts "TimeoutError"
  return 1
  rescue SocketError
  puts "SocketError"
  return 4
end
  end

  def download()
    
    if @setting.threadWait()
      return
    end

    if @list.childCount()<=0
      return
    end
    if QMessageBox.information(self, tr('確認'),tr('ダウンロードを開始しますか？'), tr('はい'), tr('いいえ'))==1
      return
    end
    
    setGui(3)
    @setting.resetBreak()
    t = Thread.new() do 
      system("qcop QPE/System 'setScreenSaverMode(int)' 0")  
      n_count=@list.childCount()
      n_as=0
      n_rev=0
      n_current=1

      item = @list.firstChild()
      while ( not(item.nil?) and not(@setting.isBreak()) )
        @lb1.setText(tr("(#{n_current}\/#{n_count})#{item.text(1).local8Bit().to_str()}"))

        n_as=downloadId(item.text(1).local8Bit().to_str(),item.text(4).local8Bit().to_str(),@setting)
        if n_as==0
          item.setText(0,tr('○'))
        end
        if n_as==1
          item.setText(0,tr('×'))
        end
        if n_as==-100
          item.setText(0,tr('□'))
        end
        n_rev+=n_as
        n_current+=1
        item = item.nextSibling()
        GC.start
     end

      puts "4 call setGUI\n"
      if n_rev<=0
        setGui(4)      
      else
        setGui(5)      
      end
      system("qcop QPE/System 'setScreenSaverMode(int)' 3")  
    end
    @setting.threadSave(t)
  end  
end


class PlayDialog < QRDialog
  def initialize(parent,url,setting)
    super(parent,"",true,0) 
    @parent=parent
    @str_url=url
    @setting=setting
    setFixedSize(@parent.width,@parent.height)
    setCaption(tr('再生できるか運次第'))
  
    system("killall mplayer >/dev/null 2>&1")

    @seek1    = '30'     # 再生時seek時間1(sec)
    @seek2    = '300'    # 再生時seek時間2(sec)
    @seek3    = '30'     # 再生時seek時間3(sec) リモコン用
    @volstep  = '10'     # zvol音量変化量

    # キー定義
    @keybind = QAccel.new(self)
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Space), self, 'pause')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Right), self, 'seekForward1')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_End),   self, 'seekForward2')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Left),  self, 'seekReverse1')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Home),  self, 'seekReverse2')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Prior), self, 'upVolume')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Next),  self, 'downVolume')
    @keybind.connectItem(@keybind.insertItem(Qt::Key_Q), self, 'close')
 
    # Remocon(CE-RH2)
    # Remocon/Play_Pause
    @keybind.connectItem(@keybind.insertItem(0x201c),        self, 'rmt_play_pause')
    # Remocon/Stop
    @keybind.connectItem(@keybind.insertItem(0x201d),        self, 'close')
    # Remocon/Up
    @keybind.connectItem(@keybind.insertItem(0x2020),        self, 'upVolume')
    # Remocon/Down
    @keybind.connectItem(@keybind.insertItem(0x2021),        self, 'downVolume')
 
    system("qcop QPE/System 'setScreenSaverMode(int)' 0  >/dev/null 2>&1")
    system("qcop QPE/System 'setScreenSaverIntervals(int,int,int)' 0 0 0  >/dev/null 2>&1")
    
    @fork = nil

#    @lays1=QVBoxLayout.new(self)
#    @bt = QPushButton.new(tr('再生'),self)
#    connect(@bt,QSIGNAL("clicked()"), self, 'cmp')
#    @lays1.addWidget(@bt)
    
    #play start
    cmp
    
    catchEvent()
  end

  # 音量Up
  def upVolume
    system("#{$zvol} +#{@volstep.to_i} >/dev/null 2>&1")
  end
  # 音量Down
  def downVolume
    system("#{$zvol} -#{@volstep.to_i} >/dev/null 2>&1")
  end

  # リモコン用
  def rmt_play_pause
      pause
  end

  # mplayerにコマンド送出
  def sendMPlayer(str)
    begin
      @send.write(str)
    rescue
    end
  end

  # シーク
  def seekForward1
    seek( @seek1 )
  end
  def seekForward2
    seek( @seek2 )
  end
  def seekForward3
    seek( @seek3 )
  end
  def seekReverse1
    seek("-#{@seek1}" )
  end
  def seekReverse2
    seek("-#{@seek2}")
  end
  def seekReverse3
    seek("-#{@seek3}")
  end
  def seek(val)
    if !@fork.nil?
      str = "seek #{val} type=0\n"
      sendMPlayer(str)
    end
  end

   # 再生/一時停止 Key_Space
  def pause
    if !@fork.nil?
      sendMPlayer("pause\n")
    end
  end

  def cmp()
    str_file = @str_url

    if not str_file.nil? then
      t = Thread.new() do 
begin
        proxy_class =Net::HTTP::Proxy(@setting.getProxy(1),@setting.getPort())
        download_url = @parent.downloadUri(str_file,proxy_class,@setting)

        rcv, @send = Socket::pair(Socket::AF_UNIX, Socket::SOCK_STREAM, 0)
        @fork = Process.fork{
          @send.close
          STDIN.reopen(rcv)
#          str_out="mplayer -slave -double -really-quiet -framedrop -double -cache " + @setting.getCache2().to_s() + " " + @setting.getPlayoption()  + " " + download_url
          str_out= $str_mplayer + @setting.getCache2().to_s() + " " + @setting.getPlayoption()  + " " + download_url

          @parent.exec2(str_out)
        }
        rcv.close
        thfork = Process.detach(@fork)
        nil while thfork.value != nil
        @send.close
        @fork = nil
rescue
        @send = nil
        @fork = nil
end
        close
      end
    end
  end

  def closeEvent(e)

    if @cancelClose
      e.ignore()
    else
      e.accept()
    end

begin
    if !@fork.nil?
      sendMPlayer("quit\n")
      Process.waitpid( @fork, 0)
      @send.close
      @fork = nil
    end
rescue    
end
    system("killall mplayer  >/dev/null 2>&1")
    
    system("qcop QPE/System 'setScreenSaverIntervals(int,int,int)' -1 -1 -1  >/dev/null 2>&1")
    system("qcop QPE/System 'setScreenSaverMode(int)' 3  >/dev/null 2>&1")

  end
  
end

class QSearchWindow < QWidget
   def initialize(parent,setting)
    super(parent)
    @parent=parent
    @setting=setting

    @lays1=QVBoxLayout.new(self)
    @lays2=QHBoxLayout.new(self)
    @lays3=QHBoxLayout.new(self)
    @lays4=QHBoxLayout.new(self)
    @lays5=QHBoxLayout.new(self)

    @list = QListView.new(self)
    @list.setSelectionMode(1)
    # 0:シングル
    # 1:アイテムタップで選択トグル
    # 2:Shift,Ctrlと併用で複数選択
    # 3:非選択

    @list.setMultiSelection(true)

    @list.addColumn(tr('Title'))
    @list.addColumn(tr('Time'))
    @list.addColumn(tr('User'))
    @list.addColumn(tr('ID'))
    @list.setAllColumnsShowFocus(true)
    @list.setColumnWidth(0, 440)
    @list.setColumnWidth(1, 60)
    @list.setColumnWidth(2, 100)
    @list.setColumnWidth(3, 100)
    
    @cb0 = QComboBox.new(self)
    @cb0.insertItem(tr('一般検索'),-1)
    @cb0.insertItem(tr('格付け検索'),-1)
    @cb0.insertItem(tr('更新順検索'),-1)
    @cb0.insertItem(tr('再生数順検索'),-1)
    @cb0.insertItem(tr('登録者検索'),-1)

    @cb1 = QComboBox.new(self)
    
    100.times do |n_num|
      @cb1.insertItem(tr((n_num+1).to_s),-1)
    end

    @ebox1 = QLineEdit.new(self)

    @bt1 = QPushButton.new(tr('YouTube検索'),self)
    connect(@bt1,QSIGNAL("clicked()"), self, 'search')

    if @setting.getPlaymode()!=0
      @bt3 = QPushButton.new(tr('再生'),self)
      connect(@bt3,QSIGNAL("clicked()"), self, 'cmp')
    else
      @bt3=nil 
    end

    @bt2 = QPushButton.new(tr('ダウンロードリストに登録'),self)
    connect(@bt2,QSIGNAL("clicked()"), self, 'sendlist')

    @lb1 = QLabel.new(tr('--'),self)

    if @setting.isVga()
      @lb1.setMinimumWidth(320)
    else
      @lb1.setMinimumWidth(160)
    end

    @pb1 = QProgressBar.new(self)

    @lays2.addWidget(@cb0)
    @lays2.addWidget(@cb1)
    @lays2.addWidget(@ebox1)
    @lays2.addWidget(@bt1)
    @lays3.addWidget(@list)
    if @bt3!=nil
      @lays4.addWidget(@bt3)
    end
    @lays4.addWidget(@bt2)
    @lays5.addWidget(@lb1)
    @lays5.addWidget(@pb1)

    @lays1.addLayout(@lays2)
    @lays1.addLayout(@lays3)
    @lays1.addLayout(@lays4)
    @lays1.addLayout(@lays5)

    @key = QAccel.new(self)
    @key.connectItem(@key.insertItem(Qt::Key_Return+CTRL,     91), self, 'pushEnter')
    @key.connectItem(@key.insertItem(Qt::Key_Enter+CTRL,      92), self, 'pushEnter')
    @key.connectItem(@key.insertItem(Qt::Key_L+CTRL,    101), self, 'pushList')
    @key.connectItem(@key.insertItem(Qt::Key_I+CTRL,    102), self, 'pushInsert')
    @key.connectItem(@key.insertItem(Qt::Key_Enter+SHIFT,103), self, 'tabChange')
    @key.connectItem(@key.insertItem(Qt::Key_Return+SHIFT,104), self, 'tabChange')
    @key.connectItem(@key.insertItem(Qt::Key_Tab+SHIFT, 105), self, 'pushTab')
    @key.connectItem(@key.insertItem(Qt::Key_Up+CTRL,   106), self, 'pushUp')
    @key.connectItem(@key.insertItem(Qt::Key_Down+CTRL, 107), self, 'pushDown')
    @key.connectItem(@key.insertItem(Qt::Key_Left+CTRL, 108), self, 'pushLeft')
    @key.connectItem(@key.insertItem(Qt::Key_Right+CTRL,109), self, 'pushRight')
    @key.connectItem(@key.insertItem(Qt::Key_0+CTRL,110), self, 'push0')
    if @setting.getPlaymode()!=0
      @key.connectItem(@key.insertItem(Qt::Key_P+CTRL,111), self, 'cmp')
    end
    @ebox1.setFocus()

  end

  def cmp()
    str_file=nil
    item = @list.currentItem()
    if item.nil?
      return
    end

    sw = PlayDialog.new(@parent,item.text(3).local8Bit().to_str(),@setting)
    sw.exec()
    system("qcop QPE/System 'applyStyle()'  >/dev/null 2>&1")
  end
  
  def push0()
    item = @list.firstChild()
    while (not item.nil?)
      if item.isSelected
        @list.setSelected(item,false)
      end
      item = item.nextSibling()
    end
  end

  def tabChange()
    @parent.setPage(2)
  end

  def setEnableMode(n_mode)
    @cb0.setEnabled(n_mode)
    @cb1.setEnabled(n_mode)
    @ebox1.setEnabled(n_mode)
    @list.setEnabled(n_mode)

    @parent.setEnabledTab(1,n_mode)

    10.times do |l|
      @key.setItemEnabled(101+l,n_mode)
    end    
  end

  def setGui(n_state)
    if n_state==0
      @lb1.setText(tr('一覧取得中'))
      @list.clear()
      setEnableMode(false)
      @bt2.setEnabled(false)
      if @bt3!=nil
        @bt3.setEnabled(false)
      end
      @bt1.setText(tr('キャンセル'))    
    end

    if n_state==1
      @lb1.setText(tr('--'))
      @pb1.setProgress(0)
      setEnableMode(true)
      @bt2.setEnabled(true)
      if @bt3!=nil
        @bt3.setEnabled(true)
      end
      @bt1.setText(tr('YouTube検索'))    
    end

    if n_state<0
	    if n_state==-1
	      @lb1.setText(tr('回線未接続'))
	    end
	    
	    if n_state==-2
	      @lb1.setText(tr('TimeOutエラー'))
	    end

	    if n_state==-3
	      @lb1.setText(tr('通信エラー'))
	    end
	    
	    @pb1.setProgress(0)
	    setEnableMode(true)
	    @bt2.setEnabled(true)
	    if @bt3!=nil
	        @bt3.setEnabled(true)
	    end
	    @bt1.setText(tr('YouTube検索'))    
	end
  end

  def listSelected()
    n_count=0
    item = @list.firstChild()
    while ( not item.nil? )
      if item.isSelected
        n_count+=1
      end
      item = item.nextSibling()
    end

    return n_count
  end

  def pushLeft
    n_num=@cb0.currentItem()
    n_num-=1
    if -1<n_num
      @cb0.setCurrentItem(n_num)
    end
  end

  def pushRight
    n_num=@cb0.currentItem()
    n_num+=1
    if 3>n_num
      @cb0.setCurrentItem(n_num)
    end
  end

  def pushUp
    n_num=@cb1.currentItem()
    n_num-=1
    if -1<n_num
      @cb1.setCurrentItem(n_num)
    end
  end

  def pushDown
    n_num=@cb1.currentItem()
    n_num+=1
    if 100>n_num
      @cb1.setCurrentItem(n_num)
    end
  end

  def pushTab
    if @ebox1.hasFocus() or @bt1.hasFocus()
      @list.setFocus()
    else
      @ebox1.setFocus()
    end
  end

  def pushList
    @list.setFocus()
  end

  def pushInsert
    @ebox1.setFocus()
  end

  def pushEnter
    if @list.hasFocus()
      sendlist()
    else
      search()
    end
  end

  def sendlist()
    n_count=0
    item = @list.firstChild()
    while ( not item.nil? )
      if item.isSelected
        @parent.sendlist(item.text(0),item.text(1).local8Bit().to_str(),item.text(2).local8Bit().to_str(),item.text(3).local8Bit().to_str())
        n_count+=1
      end
      item = item.nextSibling()
    end
    
    if n_count>0
      @lb1.setText(tr('リスト登録中'))
      @lb1.repaint()
      25.times do |l|
        @pb1.setProgress(l*4-1)
      end
      sleep 0.3
      @pb1.setProgress(0)
      @lb1.setText(tr('--'))
    end
  end

  def search_list(n_mode,str_search,n_page,setting)

    n_currentlen=0
    str_url1=""
    str_f=''    
    str_temptitle=''
    str_temptime=''
    str_tempid=''
    str_tempname=''
begin
    proxy_class = Net::HTTP::Proxy(setting.getProxy(1),setting.getPort())
    http= proxy_class.new('gdata.youtube.com')
    http.open_timeout=setting.getTimeout2()
    http.read_timeout=setting.getTimeout2()
    http.start  do |http|
  
      str_index = (n_page - 1) * 20 + 1
      str_url1=''
      if  n_mode == 1
        str_url1 = '/feeds/api/videos?alt=atom&max-results=20&orderby=rating&vq='
      elsif  n_mode == 2
        str_url1 = '/feeds/api/videos?alt=atom&max-results=20&orderby=updated&vq='
      elsif n_mode == 3
        str_url1 = '/feeds/api/videos?alt=atom&max-results=20&orderby=viewCount&vq='
      elsif n_mode == 4
        str_url1 = '/feeds/api/videos?alt=atom&max-results=20&author='
      else
        str_url1 = '/feeds/api/videos?alt=atom&max-results=20&vq='
      end  
      str_url1 += "#{str_search}&start-index=#{str_index.to_s}"
      str_f =''
      http.get(str_url1,'User-Agent'=>setting.ua,'Accept'=>setting.ap,'Accept-Language'=>setting.al,'Accept-Charset'=>setting.ac) do |byte|
        str_f += byte
        n_currentlen+=2
        @pb1.setProgress(n_currentlen)
        if setting.isBreak()
          break
        end
      end 
      list_entry = str_f.scan( /<entry>(.*?)<\/entry>/im )
      list_entry.each do |one_entry|
        str_temptitle='null'
        str_tempid ='00000000'
        str_temptime='--:--'
        str_tempname='-'
        if /<media:player url='http:\/\/www.youtube.com\/watch\?v=(.+?)'/im  =~ one_entry.to_s
          str_tempid = $1
        end
        if /<media:title type='plain'>(.+?)<\/media:title>/im  =~ one_entry.to_s
          str_temptitle = CGI::unescapeHTML($1)
        end
        if /<yt:duration seconds='(.+?)'/i  =~ one_entry.to_s
          num = $1.to_i
          str_temptime = "#{((num % 3600) / 60).to_s}:#{(num % 60).to_s}"
        end
        if /<author><name>(.+?)<\/name>.+?<\/author>/im  =~ one_entry.to_s
          str_tempname = $1
        end
        QListViewItem.new(@list, tr(str_temptitle), tr(str_temptime), tr(str_tempname), str_tempid)
      end
    end
    return 1
rescue Exception
    return -1
rescue Errno::ETIMEDOUT, TimeoutError
    return -2
rescue SocketError
    return -3
end
  end

  def search()

    if @setting.threadWait()
      return
    end
 
    if @ebox1.text().isEmpty()
      return
    end

    setGui(0)
 
    @setting.resetBreak()
    t = Thread.new() do 
   
      str_search =@ebox1.text().local8Bit().to_str()    
      n_page  =@cb1.currentText().local8Bit().to_str().to_i()
      n_mode  =@cb0.currentItem()

      str_search=URI.escape(str_search.gsub(' ','+'))

      n_ret=search_list(n_mode,str_search,n_page,@setting)

      setGui(n_ret)
    end
    @setting.threadSave(t)
  end
end

class QTubeWindow < QMainWindow
  def initialize()
    super()
    setCaption(tr($str_name))

    @oShare=ObjShare.new()

    @tabB=QTabWidget.new(self)    
    @tab1=QSearchWindow.new(self,@oShare)
    @tab2=QDownloadWindow.new(self,@oShare)
    @tab4=QSettingWindow.new(self,@oShare)

    @lays1=QVBoxLayout.new(self)  
    @lays1.addWidget(@tabB)

    @tabB.addTab(@tab1,tr('検索'))    
    @tabB.addTab(@tab2,tr('ダウンロード'))    
    @tabB.addTab(@tab4,tr('設定'))    
    
    catchEvent
  end

  def exec2(str)
    exec str
  end

  def downloadUri(str_id,proxy_class,setting)
    return @tab2.downloadUri(str_id,proxy_class,setting)
  end

  def sendlist(str_title,str_time,str_user,strid)
    @tab2.insert(str_title,str_time,str_user,strid)
  end

  def setPage(n_page)
    if n_page==1
      @tabB.showPage(@tab1)
    end
    if n_page==2
      @tabB.showPage(@tab2)
    end
  end

  def setEnabledTab(n_page, b_mode)

    if n_page!=1
      @tab1.setEnabled(b_mode)
    end
    if n_page!=2
      @tab2.setEnabled(b_mode)
    end
    if n_page!=4
      @tab4.setEnabled(b_mode)
    end
  end

  def closeEvent(e)
    @oShare.exit()
    e.accept()
  end
end

#メイン
$defaultCodec = QTextCodec.codecForName("utf8")
app = QPEApplication.new([$0]+ARGV)
app.setDefaultCodec($defaultCodec)
#QApplication.setFont(QFont.new("lcfont", 18))
app.showMainWidget(QTubeWindow.new)
app.exec
